/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package aspectModel.impl;

import aspectModel.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AspectModelFactoryImpl extends EFactoryImpl implements AspectModelFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AspectModelFactory init() {
		try {
			AspectModelFactory theAspectModelFactory = (AspectModelFactory)EPackage.Registry.INSTANCE.getEFactory("http://aspectModel"); 
			if (theAspectModelFactory != null) {
				return theAspectModelFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new AspectModelFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AspectModelFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case AspectModelPackage.ASPECT: return createAspect();
			case AspectModelPackage.ADVICE: return createAdvice();
			case AspectModelPackage.POINT_CUT: return createPointCut();
			case AspectModelPackage.PROPERTIE: return createPropertie();
			case AspectModelPackage.PC_NODE: return createPCNode();
			case AspectModelPackage.PC_REFERENCE: return createPCReference();
			case AspectModelPackage.ADV_NODE: return createAdvNode();
			case AspectModelPackage.ADV_REFERENCE: return createAdvReference();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case AspectModelPackage.POINT_CUT_APPLICATION_CONDITIONS:
				return createPointCutApplicationConditionsFromString(eDataType, initialValue);
			case AspectModelPackage.ADVICE_APPLICATION_CONDITIONS:
				return createAdviceApplicationConditionsFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case AspectModelPackage.POINT_CUT_APPLICATION_CONDITIONS:
				return convertPointCutApplicationConditionsToString(eDataType, instanceValue);
			case AspectModelPackage.ADVICE_APPLICATION_CONDITIONS:
				return convertAdviceApplicationConditionsToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Aspect createAspect() {
		AspectImpl aspect = new AspectImpl();
		return aspect;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Advice createAdvice() {
		AdviceImpl advice = new AdviceImpl();
		return advice;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PointCut createPointCut() {
		PointCutImpl pointCut = new PointCutImpl();
		return pointCut;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Propertie createPropertie() {
		PropertieImpl propertie = new PropertieImpl();
		return propertie;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PCNode createPCNode() {
		PCNodeImpl pcNode = new PCNodeImpl();
		return pcNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PCReference createPCReference() {
		PCReferenceImpl pcReference = new PCReferenceImpl();
		return pcReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdvNode createAdvNode() {
		AdvNodeImpl advNode = new AdvNodeImpl();
		return advNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdvReference createAdvReference() {
		AdvReferenceImpl advReference = new AdvReferenceImpl();
		return advReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PointCutApplicationConditions createPointCutApplicationConditionsFromString(EDataType eDataType, String initialValue) {
		PointCutApplicationConditions result = PointCutApplicationConditions.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertPointCutApplicationConditionsToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdviceApplicationConditions createAdviceApplicationConditionsFromString(EDataType eDataType, String initialValue) {
		AdviceApplicationConditions result = AdviceApplicationConditions.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertAdviceApplicationConditionsToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AspectModelPackage getAspectModelPackage() {
		return (AspectModelPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static AspectModelPackage getPackage() {
		return AspectModelPackage.eINSTANCE;
	}

} //AspectModelFactoryImpl
